diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 4f7efce80..02809c47e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -512,63 +518,37 @@ public class FontRendererDefault implements FontRenderer {
         }
     }
     @Override
-    public @NotNull List<String> splitCharsIntoLines(@NotNull final CharSequence chars, final double maxWidth, @Nullable final List<String> output) {
+    public @NotNull List<String> splitCharsIntoLines(@NotNull final Font font, @NotNull final CharSequence chars, final double maxWidth, @Nullable final List<String> output) {
         final @NotNull List<String> o = output == null ? new ArrayList<>() : output;
         o.clear();
-        splitLineIntoConstrainedLine(chars, maxWidth, o);
+        splitLineIntoConstrainedLine(font, chars, maxWidth, o);
         return o;
     }
 
     @Override
-    public @NotNull List<String> splitLinesIntoConstrainedLines(@NotNull final List<String> lines, final double maxWidth, @Nullable final List<String> output) {
+    public @NotNull List<String> splitLinesIntoConstrainedLines(@NotNull final Font font, @NotNull final List<String> lines, final double maxWidth, @Nullable final List<String> output) {
         final @NotNull List<String> o = output == null ? new ArrayList<>() : output;
         o.clear();
         for (int i = 0; i < lines.size(); i++) {
-            splitLineIntoConstrainedLine(lines.get(i), maxWidth, o);
+            splitLineIntoConstrainedLine(font, lines.get(i), maxWidth, o);
         }
         return o;
     }
 
     @Override
-    public double heightOfConstrainedChars(@NotNull final CharSequence chars, final double maxWidth) {
+    public double heightOfConstrainedChars(@NotNull final Font font, @NotNull final CharSequence chars, final double maxWidth) {
         splitCharsIntoLines(chars, maxWidth, this.localStringList);
-        return this.localStringList.size() * (fontHeight() + 1);
+        return this.localStringList.size() * (font.fontHeight() + 1);
     }
 
     @Override
-    public double heightOfLines(@NotNull final List<@NotNull String> lines, final double maxWidth) {
+    public double heightOfLines(@NotNull final Font font, @NotNull final List<@NotNull String> lines, final double maxWidth) {
         splitLinesIntoConstrainedLines(lines, maxWidth, this.localStringList);
-        return this.localStringList.size() * (fontHeight() + 1);
-    }
-
-    @Override
-    public void init(@NotNull final TexturePackList packList) {
-        this.font.init(packList);
-        this.fallbackFont.init(packList);
+        return this.localStringList.size() * (font.fontHeight() + 1);
     }
 
     @Override
-    public int textureForChar(final char c) {
-        return getFont(c).textureForChar(c);
-    }
-
-    @Override
-    public char getObfuscatedChar(final char c, final Random random) {
-        return getFont(c).getObfuscatedChar(c, random);
-    }
-
-    @Override
-    public boolean canRenderChar(final char c) {
-        return this.font.canRenderChar(c) || this.fallbackFont.canRenderChar(c);
-    }
-
-    @Override
-    public double charWidthDouble(final char c) {
-        return getFont(c).charWidthDouble(c);
-    }
-
-    @Override
-    public double stringWidthDouble(final CharSequence chars) {
+    public double stringWidthDouble(@NotNull final Font font, final @NotNull CharSequence chars) {
         double width = 0;
         final int length = chars.length();
         for (int i = 0; i < length; i++) {
@@ -601,29 +581,13 @@ public class FontRendererDefault implements FontRenderer {
                 }
             }
 
-            width += charWidthDouble(c);
+            width += font.canRenderChar(c) ? font.charWidthDouble(c) : this.fallbackFont.charWidthDouble(c);
         }
         return width;
     }
 
-    @Override
-    public int fontHeight() {
-        return getFont().fontHeight();
-    }
-
-    @Override
-    public double renderChar(final Tessellator tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
-        return getFont(c).renderChar(tessellator, c, x, y, z, italics);
-    }
-
-    protected @NotNull Font getFont(final char c) {
-        if (Minecraft.getMinecraft().gameSettings.forceUnicodeFont.value || !this.font.canRenderChar(c)) return this.fallbackFont;
-        return this.font;
-    }
-
-    protected @NotNull Font getFont() {
-        if (Minecraft.getMinecraft().gameSettings.forceUnicodeFont.value) return this.fallbackFont;
-        return this.font;
+    public @NotNull Font getFont() {
+        return this.font == null ? Minecraft.getMinecraft().gameSettings.font.value : this.font;
     }
 
     public static int decodeHexToInt(final @NotNull CharSequence hexSequence) throws NumberFormatException {
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontUnicode.java b/game/client/src/main/java/net/minecraft/client/render/font/FontUnicode.java
index 911b9c463..27d4ff1cc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontUnicode.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontUnicode.java
@@ -1,15 +1,9 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.TextureManager;
 import org.jetbrains.annotations.NotNull;
 
 public class FontUnicode extends FontFile {
-    public FontUnicode(final @NotNull TextureManager textureManager) {
-        super(textureManager, "/font/glyph_%02X.png", "/font/glyph_sizes.bin");
+    public FontUnicode(@NotNull final String key) {
+        super(key, "/assets/minecraft/textures/gui/font/unicode/glyph_%02X.png", "/assets/minecraft/textures/gui/font/unicode/glyph_sizes.bin");
     }
-    @Override
-    public boolean canRenderChar(final char c) {
-        return c == ' ' || textureForChar(c) != 0;
-    }
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/Fonts.java b/game/client/src/main/java/net/minecraft/client/render/font/Fonts.java
new file mode 100644
index 000000000..140be015d
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/Fonts.java
@@ -0,0 +1,56 @@
+package net.minecraft.client.render.font;
+
+import net.minecraft.client.render.texturepack.TexturePackList;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+public class Fonts {
+    private static final @NotNull List<Font> permanentFonts = new ArrayList<>();
+    private static final @NotNull List<Font> availableFonts = new ArrayList<>();
+
+    private static final @NotNull Map<@NotNull String, @NotNull Font> fontMap = new HashMap<>();
+
+    public static final Font DEFAULT = registerFont(new FontDefault("default"), true);
+    public static final Font MONOSPACE = registerFont(new FontMonospace("monospace"), true);
+    public static final Font UNICODE = registerFont(new FontUnicode("unicode"), true);
+
+    public static @NotNull Font registerFont(@NotNull final Font font, final boolean permanent) {
+        fontMap.put(font.getKey(), font);
+        if (permanent && !permanentFonts.contains(font)) permanentFonts.add(font);
+        if (!availableFonts.contains(font)) availableFonts.add(font);
+        return font;
+    }
+
+    public static void refreshFonts(@NotNull final TexturePackList texturePackList) {
+        fontMap.clear();
+        availableFonts.clear();
+        availableFonts.addAll(permanentFonts);
+
+        for (final Font font : availableFonts) {
+            registerFont(font, false);
+        }
+
+        fontMap.values().forEach(font -> font.init(texturePackList));
+    }
+
+    public static int fontAmount() {
+        return availableFonts.size();
+    }
+
+    public static @NotNull Font fontAtIndex(final int index) {
+        if (index < 0 || index >= availableFonts.size()) return DEFAULT;
+        return availableFonts.get(index);
+    }
+
+    public static int indexForFont(final @NotNull Font font) {
+        return availableFonts.indexOf(font);
+    }
+
+    public static @NotNull Font fontWithKey(@NotNull final String key) {
+        return fontMap.getOrDefault(key, DEFAULT);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleBase.java b/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleBase.java
similarity index 71%
rename from game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleBase.java
rename to game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleBase.java
index bbf262aea..24e79b7a0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleBase.java
@@ -1,7 +1,5 @@
-package net.minecraft.client.render.font.renderhelper;
+package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.font.SF;
-import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
@@ -9,8 +7,10 @@ import org.jetbrains.annotations.Nullable;
 
 @SuppressWarnings("unused")
 public abstract class RenderDoubleBase {
+    protected @NotNull FontRenderer fontRenderer;
     protected @NotNull Tessellator tessellator;
     protected @NotNull CharSequence chars;
+    protected @NotNull Font font;
     protected double x;
     protected double y;
     protected double z;
@@ -19,11 +19,15 @@ public abstract class RenderDoubleBase {
     protected long @Nullable [] configBuffer;
     protected long config;
     protected boolean shadow;
+    protected boolean needCall;
     RenderDoubleBase() {
 
     }
 
-    public @NotNull RenderDoubleBase init(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public @NotNull RenderDoubleBase init(@NotNull final FontRenderer fontRenderer, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        if (this.needCall) throw new IllegalStateException("Init called before prior draw call!");
+        this.fontRenderer = fontRenderer;
+        this.font = this.fontRenderer.getFont();
         this.tessellator = tessellator;
         this.chars = chars;
         this.x = x;
@@ -32,8 +36,10 @@ public abstract class RenderDoubleBase {
         this.xPosBuffer = xPosBuffer;
         this.yPosBuffer = yPosBuffer;
         this.configBuffer = configBuffer;
-        this.config = FontHelper.CONFIG_DEFAULT;
+        this.config = FontRenderer.CONFIG_DEFAULT;
         this.shadow = false;
+
+        this.needCall = true;
         return this;
     }
 
@@ -43,7 +49,7 @@ public abstract class RenderDoubleBase {
     }
 
     public @NotNull RenderDoubleBase resetConfig() {
-        this.config = FontHelper.CONFIG_DEFAULT;
+        this.config = FontRenderer.CONFIG_DEFAULT;
         this.shadow = false;
         this.z = 0;
         return this;
@@ -64,6 +70,11 @@ public abstract class RenderDoubleBase {
         return this;
     }
 
+    public @NotNull RenderDoubleBase setFont(final @NotNull Font font) {
+        this.font = font;
+        return this;
+    }
+
     public @NotNull RenderDoubleBase setItalic() {
         this.config = SF.setItalic(this.config);
         return this;
@@ -94,5 +105,5 @@ public abstract class RenderDoubleBase {
         return this;
     }
 
-    public abstract void call(@NotNull FontRenderer fontRenderer);
+    public abstract void call();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleConstrainedBase.java b/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleConstrainedBase.java
similarity index 75%
rename from game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleConstrainedBase.java
rename to game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleConstrainedBase.java
index 56904dfb6..078d8ab3d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderDoubleConstrainedBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleConstrainedBase.java
@@ -1,8 +1,5 @@
-package net.minecraft.client.render.font.renderhelper;
+package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.font.Alignment;
-import net.minecraft.client.render.font.SF;
-import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
@@ -10,8 +7,10 @@ import org.jetbrains.annotations.Nullable;
 
 @SuppressWarnings("unused")
 public abstract class RenderDoubleConstrainedBase {
+    protected @NotNull FontRenderer fontRenderer;
     protected @NotNull Tessellator tessellator;
     protected @NotNull CharSequence chars;
+    protected @NotNull Font font;
     protected double x;
     protected double y;
     protected double z;
@@ -23,11 +22,15 @@ public abstract class RenderDoubleConstrainedBase {
     protected @NotNull Alignment alignment;
     protected long config;
     protected boolean shadow;
+    protected boolean needCall;
     RenderDoubleConstrainedBase() {
 
     }
 
-    public @NotNull RenderDoubleConstrainedBase init(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double maxWidth, final double maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public @NotNull RenderDoubleConstrainedBase init(@NotNull final FontRenderer fontRenderer, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double maxWidth, final double maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        if (this.needCall) throw new IllegalStateException("Init called before prior draw call!");
+        this.fontRenderer = fontRenderer;
+        this.font = this.fontRenderer.getFont();
         this.tessellator = tessellator;
         this.chars = chars;
         this.x = x;
@@ -39,8 +42,10 @@ public abstract class RenderDoubleConstrainedBase {
         this.yPosBuffer = yPosBuffer;
         this.configBuffer = configBuffer;
         this.alignment = Alignment.LEFT;
-        this.config = FontHelper.CONFIG_DEFAULT;
+        this.config = FontRenderer.CONFIG_DEFAULT;
         this.shadow = false;
+
+        this.needCall = true;
         return this;
     }
 
@@ -50,7 +55,7 @@ public abstract class RenderDoubleConstrainedBase {
     }
 
     public @NotNull RenderDoubleConstrainedBase resetConfig() {
-        this.config = FontHelper.CONFIG_DEFAULT;
+        this.config = FontRenderer.CONFIG_DEFAULT;
         this.shadow = false;
         this.z = 0;
         return this;
@@ -71,6 +76,11 @@ public abstract class RenderDoubleConstrainedBase {
         return this;
     }
 
+    public @NotNull RenderDoubleConstrainedBase setFont(final @NotNull Font font) {
+        this.font = font;
+        return this;
+    }
+
     public @NotNull RenderDoubleConstrainedBase setItalic() {
         this.config = SF.setItalic(this.config);
         return this;
@@ -106,5 +116,5 @@ public abstract class RenderDoubleConstrainedBase {
         return this;
     }
 
-    public abstract void call(@NotNull FontRenderer fontRenderer);
+    public abstract void call();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerBase.java b/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerBase.java
similarity index 71%
rename from game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerBase.java
rename to game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerBase.java
index c92e2ad89..3282f48cd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerBase.java
@@ -1,7 +1,5 @@
-package net.minecraft.client.render.font.renderhelper;
+package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.font.SF;
-import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
@@ -9,8 +7,10 @@ import org.jetbrains.annotations.Nullable;
 
 @SuppressWarnings("unused")
 public abstract class RenderIntegerBase {
+    protected @NotNull FontRenderer fontRenderer;
     protected @NotNull Tessellator tessellator;
     protected @NotNull CharSequence chars;
+    protected @NotNull Font font;
     protected int x;
     protected int y;
     protected double z;
@@ -19,11 +19,15 @@ public abstract class RenderIntegerBase {
     protected long @Nullable [] configBuffer;
     protected long config;
     protected boolean shadow;
+    protected boolean needCall;
     RenderIntegerBase() {
 
     }
 
-    public @NotNull RenderIntegerBase init(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public @NotNull RenderIntegerBase init(@NotNull final FontRenderer fontRenderer, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        if (this.needCall) throw new IllegalStateException("Init called before prior draw call!");
+        this.fontRenderer = fontRenderer;
+        this.font = this.fontRenderer.getFont();
         this.tessellator = tessellator;
         this.chars = chars;
         this.x = x;
@@ -32,8 +36,10 @@ public abstract class RenderIntegerBase {
         this.xPosBuffer = xPosBuffer;
         this.yPosBuffer = yPosBuffer;
         this.configBuffer = configBuffer;
-        this.config = FontHelper.CONFIG_DEFAULT;
+        this.config = FontRenderer.CONFIG_DEFAULT;
         this.shadow = false;
+
+        this.needCall = true;
         return this;
     }
 
@@ -43,7 +49,7 @@ public abstract class RenderIntegerBase {
     }
 
     public @NotNull RenderIntegerBase resetConfig() {
-        this.config = FontHelper.CONFIG_DEFAULT;
+        this.config = FontRenderer.CONFIG_DEFAULT;
         this.shadow = false;
         this.z = 0;
         return this;
@@ -64,6 +70,11 @@ public abstract class RenderIntegerBase {
         return this;
     }
 
+    public @NotNull RenderIntegerBase setFont(final @NotNull Font font) {
+        this.font = font;
+        return this;
+    }
+
     public @NotNull RenderIntegerBase setItalic() {
         this.config = SF.setItalic(this.config);
         return this;
@@ -94,5 +105,5 @@ public abstract class RenderIntegerBase {
         return this;
     }
 
-    public abstract void call(@NotNull FontRenderer fontRenderer);
+    public abstract void call();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerConstrainedBase.java b/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerConstrainedBase.java
similarity index 76%
rename from game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerConstrainedBase.java
rename to game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerConstrainedBase.java
index 2abb11678..daddc98e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/renderhelper/RenderIntegerConstrainedBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerConstrainedBase.java
@@ -1,8 +1,5 @@
-package net.minecraft.client.render.font.renderhelper;
+package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.font.Alignment;
-import net.minecraft.client.render.font.SF;
-import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
@@ -10,8 +7,10 @@ import org.jetbrains.annotations.Nullable;
 
 @SuppressWarnings("unused")
 public abstract class RenderIntegerConstrainedBase {
+    protected @NotNull FontRenderer fontRenderer;
     protected @NotNull Tessellator tessellator;
     protected @NotNull CharSequence chars;
+    protected @NotNull Font font;
     protected int x;
     protected int y;
     protected double z;
@@ -23,11 +22,15 @@ public abstract class RenderIntegerConstrainedBase {
     protected @NotNull Alignment alignment;
     protected long config;
     protected boolean shadow;
+    protected boolean needCall;
     RenderIntegerConstrainedBase() {
 
     }
 
-    public @NotNull RenderIntegerConstrainedBase init(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final int maxWidth, final int maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+    public @NotNull RenderIntegerConstrainedBase init(@NotNull final FontRenderer fontRenderer, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final int maxWidth, final int maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        if (this.needCall) throw new IllegalStateException("Init called before prior draw call!");
+        this.fontRenderer = fontRenderer;
+        this.font = this.fontRenderer.getFont();
         this.tessellator = tessellator;
         this.chars = chars;
         this.x = x;
@@ -39,8 +42,10 @@ public abstract class RenderIntegerConstrainedBase {
         this.yPosBuffer = yPosBuffer;
         this.configBuffer = configBuffer;
         this.alignment = Alignment.LEFT;
-        this.config = FontHelper.CONFIG_DEFAULT;
+        this.config = FontRenderer.CONFIG_DEFAULT;
         this.shadow = false;
+
+        this.needCall = true;
         return this;
     }
 
@@ -50,7 +55,7 @@ public abstract class RenderIntegerConstrainedBase {
     }
 
     public @NotNull RenderIntegerConstrainedBase resetConfig() {
-        this.config = FontHelper.CONFIG_DEFAULT;
+        this.config = FontRenderer.CONFIG_DEFAULT;
         this.shadow = false;
         this.z = 0;
         return this;
@@ -71,6 +76,11 @@ public abstract class RenderIntegerConstrainedBase {
         return this;
     }
 
+    public @NotNull RenderIntegerConstrainedBase setFont(final @NotNull Font font) {
+        this.font = font;
+        return this;
+    }
+
     public @NotNull RenderIntegerConstrainedBase setItalic() {
         this.config = SF.setItalic(this.config);
         return this;
@@ -106,5 +116,5 @@ public abstract class RenderIntegerConstrainedBase {
         return this;
     }
 
-    public abstract void call(@NotNull FontRenderer fontRenderer);
+    public abstract void call();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 998a80791..96c185e2e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -210,7 +209,7 @@ public class ItemModelStandard extends ItemModel{
             final String s = override != null ? override : "" + itemstack.stackSize;
             GL11.glDisable(GL_LIGHTING);
             GL11.glDisable(GL_DEPTH_TEST);
-            FontHelper.render(tessellator, s, (x + 19) - 2 - fontRenderer.stringWidth(s), y + 6 + 3).setShadow().setColor(0xffffff | (a << 24)).call(fontRenderer);
+            fontRenderer.render(tessellator, s, (x + 19) - 2 - fontRenderer.stringWidth(s), y + 6 + 3).setShadow().setColor(0xffffff | (a << 24)).call();
             GL11.glEnable(GL_LIGHTING);
             GL11.glEnable(GL_DEPTH_TEST);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 119be40f2..2df4fc084 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -236,7 +236,7 @@ public class TexturePackList
 		for (int i = 0; i < this.selectedPacks.size(); i++) {
 			if (this.selectedPacks.get(i).hasFile(path)) return true;
 		}
-		return false;
+		return this.defaultTexturePack.hasFile(path);
 	}
 
 	public @Nullable TexturePack getHighestPriorityTexturePackWithFile(String path) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index bd6b3d8ea..345adb7fa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -3,7 +3,6 @@ package net.minecraft.client.render.tileentity;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.model.ModelSign;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -109,7 +108,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
             {
                 text = "> " + text + " <";
             }
-            FontHelper.render(t, text, -sr.stringWidth(text) / 2, line * 10 - tileEntity.signText.length * 5).setColor(color).call(sr);
+            sr.render(t, text, -sr.stringWidth(text) / 2, line * 10 - tileEntity.signText.length * 5).setColor(color).call();
         }
         GL11.glPopMatrix();
 
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index e70b289c2..8d1c17267 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -3,7 +3,6 @@ package net.minecraft.client.util.debug;
 import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.core.util.debug.Debug;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.Display;
@@ -119,10 +118,10 @@ public class DebugRender {
 		
 		int fps = Debug.getFps();
 		if(fps >= 0) {
-			FontHelper.render(t, "fps: " + fps, x1, y1 - 2 * lineHeight).call(sr);
+			sr.render(t, "fps: " + fps, x1, y1 - 2 * lineHeight).call();
 		}
-		FontHelper.render(t, "avg: " + (getAvgTime(frametimes) / 1000.0) + " ms", x1, y1 - lineHeight).call(sr);
-		FontHelper.render(t, selectedProfiler.name + ": ", x1, y1).call(sr);
+		sr.render(t, "avg: " + (getAvgTime(frametimes) / 1000.0) + " ms", x1, y1 - lineHeight).call();
+		sr.render(t, selectedProfiler.name + ": ", x1, y1).call();
 		for(int i=0; i < selectedProfiler.allProfilers.size(); i++) {
 			Profiler profiler = selectedProfiler.allProfilers.get(i);
 
@@ -130,7 +129,7 @@ public class DebugRender {
 			if(i == selection) {
 				color = 0xFF00FFFF;
 			}
-			FontHelper.render(t, i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight).setColor(color).call(sr);
+			sr.render(t, i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight).setColor(color).call();
 		}
 		glEnable(GL_ALPHA_TEST);
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/lang/text/Text.java b/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
index fef4477b0..d5dfcc64e 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/text/Text.java
@@ -1,9 +1,8 @@
 package net.minecraft.core.lang.text;
 
 import net.minecraft.core.net.command.TextFormatting;
-import org.jetbrains.annotations.NotNull;
 
-public abstract class Text implements CharSequence {
+public abstract class Text {
     public static Text text() {
         return new ChainText();
     }
@@ -36,21 +35,4 @@ public abstract class Text implements CharSequence {
     public Text fmt(TextFormatting formatting, Text text) {
         return new ChainText(this, new FormattedText(formatting, text));
     }
-
-    // TODO consider a more optimized implementation if we keep this as a char sequence
-    @Override
-    public int length() {
-        return toString().length();
-    }
-
-    @Override
-    public char charAt(int index) {
-        return toString().charAt(index);
-    }
-
-    @NotNull
-    @Override
-    public CharSequence subSequence(int start, int end) {
-        return toString().subSequence(start, end);
-    }
 }
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index f1e88401e..c8bb6b258 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -113,6 +113,7 @@ options.colorCorrection.low=Low
 options.colorCorrection.high=High
 options.sneakToggle=Toggle Sneaking
 options.tooltipStyle=Tooltip Style
+options.font=Font
 options.fog=Enable Fog
 options.hideUndiscoveredItems=Hide Undiscovered Items
 options.forceUnicodeFont=Force Unicode Font
@@ -197,6 +198,10 @@ options.tooltipStyle.redstone_goggles=Redstone Goggles
 options.tooltipStyle.creep-o-vision=Creep-o-Vision
 options.tooltipStyle.steve=Steve
 
+options.font.default=Default
+options.font.unicode=Unicode
+options.font.monospace=Monospace
+
 options.player.left.handed=Left Handed
 options.player.cape=Cape
 options.player.hat=Hat
